<?php

function colorcode($r, $g, $b) {
  return '#' . str_pad(dechex($r), 2, 0, STR_PAD_LEFT)
             . str_pad(dechex($g), 2, 0, STR_PAD_LEFT)
             . str_pad(dechex($b), 2, 0, STR_PAD_LEFT);
}

function abssqr($re, $im) {
  return $re*$re + $im*$im;
}

$i = $_GET['i'];
$c_abs = cos($i/200);
$c_abs = 0.8*$c_abs*$c_abs + 0.3;
$c_re = $c_abs*cos($i/10);
$c_im = $c_abs*sin($i/10);

$field = '';
for($row = 0; $row<30; ++$row) {
  for($col = 0; $col < 40; ++$col) {
    $z_im = (15-$row)/12;
    $z_re = ($col-20)/15;
#    $field .= '<!--'.$z_re.';'.$z_im.'-->';
    # The actual julia processing
    for($iter = 0; ($iter < 20) && abssqr($z_re, $z_im)<3; ++$iter) {
      # z = z*z + c
      $tz_re = - $z_im*$z_im + $z_re*$z_re + $c_re;
      $z_im = 2*$z_im*$z_re + $c_im;
      $z_re = $tz_re;
    }
    
#    $field .= '<span style="background:'.colorcode(255-12*$iter,7*$iter,210-19*abs($iter-10)).'">'.($iter<10?'&#160;':'').$iter.'&#160;</span>';
    $field .= '<span style="background:'.colorcode(255-12*$iter,7*$iter,210-19*abs($iter-10)).'">&#160;&#160;&#160;</span>';
  }
  $field .= "<br/>\n";
}

$greet_op = min(max(0,($i%100-30)/50), 0.7);
?>
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>"Complex" by kaj</title>
    <meta http-equiv="refresh" content="0;url=deadline.php?i=<?echo $i+1?>"/>
    <style type="text/css">
      .box { background:#000000;border: solid 1px #00ff00;-moz-border-radius:1ex; padding: 1ex 1em;}
      h2, ul { margin: 0; padding: 0; }
      h2 { border-bottom: solid 1px #00ff00; }
      li { margin: 0 -1em 0 1em; padding: 0; }
    </style>
  </head>
  
  <body style="background:#000000;color:#00ff00;">
    <h1 style="text-align:center;">&#x201D;Complex&#x201D; by kaj</h1>
    <p style="text-align:center;"><?php echo $c_abs; ?></p>
    <div style="text-align:center;font-size:80%;font-family:monospace;">
      <?php echo $field?>
    </div>

    <div class="box" style="font-size:60%;border: solid 1px #00aa00;color:#00aa00;margin:1em 15%;">
      This hack was written just before the compo at deadline.  Then
      it was accidentaly overwritten, so I had to rewrite it from scratch.
      This version differs slightly from the version shown at deadline
    </div>

    <div class="box" style="position:absolute;top:<?echo 40+30*sin($i/19)?>%;left:<?echo 40+38*sin($i/12)?>%;width:9em;-moz-opacity:<?echo $greet_op?>;">
      <h2>Greetings</h2>
      <ul>
	<li>elmindreda</li>
	<li>psychad</li>
	<li>nicon</li>
	<li>capitol</li>
	<li>haba</li>
	<li>dicander</li>
	<li>katy</li>
	<li>hackerence crew</li>
      </ul>
    </div>
  </body>
</html>
